<template>
    <v-row>
        <v-col cols="5">
            <v-select
                v-model="dialCode"
                :errors="errors"
                :items="countryLookup"
                item-text="name"
                item-value="dialCode"
                class="dial-code"
                :cache-items="true"
                hide-details="auto"
                solo
            >
                <template slot="selection" slot-scope="data">
                    <span class="text-truncate d-inline-block">
                        {{ data.item.dialCode }}
                    </span>
                </template>
                <template slot="item" slot-scope="data">
                    <img
                        class="mr-2"
                        :src="`https://www.countryflags.io/${data.item.countryCode}/flat/24.png`"
                    />
                    {{ data.item.name }} {{ data.item.dialCode }}
                </template>
            </v-select>
        </v-col>
        <v-col cols="7">
            <v-text-field
                v-model="phone"
                :error-messages="errors"
                class="phone"
                hide-details="auto"
                @keydown="numberOnly"
                type="tel"
                solo
            />
        </v-col>
    </v-row>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import parsePhoneNumber, { CountryCallingCode } from 'libphonenumber-js'
import { Prop, Watch } from 'vue-property-decorator'
import { NationalNumber } from 'libphonenumber-js/types'
import countryLookup from '../assets/plugins/countries.json'

@Component
export default class TelInput extends Vue {
    @Prop({ type: String, default: '' }) value!: any
    @Prop({ type: Array, default: '' }) errors!: any
    dialCode: CountryCallingCode | string = ''
    phone: NationalNumber | string = ''
    items: any[] = []
    contactNumber: any[] = []
    countryLookup: any = ''

    created() {
        this.countryLookup = countryLookup.filter((x) => {
            return true
        })
    }

    get result(): string | undefined {
        return this.dialCode.toString() + this.phone.toString()
    }

    numberOnly(event: any) {
        const charCode = event.which ? event.which : event.keyCode
        if (
            charCode > 31 &&
            (charCode < 48 || charCode > 57) &&
            charCode !== 46
        ) {
            event.preventDefault()
        }
    }

    requiredRules(v) {
        if (v) {
            return true
        } else {
            return 'This field is required'
        }
    }

   /*  @Watch('dialCode')
    retrieveDialCode() {
        if (this.dialCode.length > 1 {
            this.dialCode = 
        })
    } */

    @Watch('dialCode')
    onDialCodeChange() {
        this.$emit('input', this.result)
    }

    @Watch('phone')
    onPhoneChange() {
        this.$emit('input', this.result)
    }

    @Watch('value')
    assignValue() {
        if (this.value === '') {
            this.phone = this.value
        } else if (this.value && this.phone === '') {
            const phone = parsePhoneNumber(this.value)
            if (phone) {
                this.phone = phone.nationalNumber || ''
                this.dialCode =
                    this.countryLookup.find(
                        (c) => c.countryCode === phone.country
                    ).dialCode || ''
            }
        }
    }

}
</script>

<style scoped>
.v-text-field {
    margin: unset;
    padding: 4px;
}
</style>
